	#include<iostream>
	#include <fstream>
	#include <vector>
	#include<string>
	#include <stdlib.h>
	#include <algorithm>
	using namespace std;
	
	class Dictionary
	{
		public:
			vector<Word> words;
			void loadDictionary();
	};
	
	//loads dictionary.txt file into vector of Words
	void Dictionary:: loadDictionary()
	{
		fstream file("dictionary_2022S2.txt",ios::in);
	    if (file.is_open())
	   {
		string line;
		int i = 0;
		string n,def,t;
		while (getline(file, line))
	    {
	    	if(i==0)
	    	{
	    		i++;
	    		continue;
			}
			else
			{
			if(line.compare("--Next word:")==0)	
			{
				getline(file, n);
				transform(n.begin(), n.end(), n.begin(), ::tolower);
				getline(file,def);
				getline(file, t);
				Word w(n,t,def);
				words.push_back(w);
			}
			}
	    }
	}
	 file.close();
	}
	
	//check if a string is palindrome or not
	int isPalindrome(string S)
		{
	        int n=S.length();
	        for(int i=0;i<n/2;i++)
	        {
	            if(S[i]!=S[n-1-i])
	            {
	                return 0;
	            }
	        }
	        return 1;
		}
		
	class ExtendedDictionary: public Dictionary
	{
		public:
			void showPalindromes();
			void showAnagrams(string);
			void guessingGame();
			void wordle();
			string getresult(char,int,string);
	};
	
	//show all the palindromes present in vector
	void ExtendedDictionary::showPalindromes()
	{
		string w;
		 for (int i = 0; i < words.size(); i++)
		 {
		 	w = words[i].name;
	        if(isPalindrome(w))
	        {
	        cout << w << endl;
			}
	}
	}
	
	//show all the anagrams corresponding to passed argument
	void ExtendedDictionary::showAnagrams(string word)
	{
	     string w;
	     sort(word.begin(), word.end());
		 for (int i = 0; i < words.size(); i++)
		 {
		 	w = words[i].name;
	        sort(w.begin(), w.end());
	        if(w.compare(word)==0)
	        cout<<w<<endl;
	}
	}
	
	//Play guessing game in which definition is provided and one need to guess the word
	void ExtendedDictionary::guessingGame()
	{
		 string word;
	     int i= rand()%words.size();
	     string w = words[i].name;
	     string def = words[i].definition;
	     cout<<"\n\n";
	     cout<<def<<endl;
	     cout<<"\nGuess the word"<<endl;
	     cin>>word;
	     transform(word.begin(), word.end(), word.begin(), ::tolower);
	     if(w.compare(word)==0)
	     {
	     	cout<<"Correctly guesses, congrats!";
		 }
		 else
		 {
		 	cout<<"First letter of word is: "<<w[0]<<endl;
		 	cout<<"Guess the word again"<<endl;
	        cin>>word;
	        if(w.compare(word)==0)
	        {
	         	cout<<"Correctly guesses, congrats!"<<endl;
		    }
		    else
		    {
		    	cout<<"Second letter of word is: "<<w[1]<<endl;
		    	cout<<"Guess the word again"<<endl;
	            cin>>word;
	            if(w.compare(word)==0)
	            {
	            	cout<<"Correctly guesses, congrats!";
		        }
		        else
		        {
		    	cout<<"Sorry you lost the number of attempts. Word is: "<<w<<endl;
			    }
			}
		 }
	}
	
	
	//get result based on guessed word of user
	string ExtendedDictionary::getresult(char c,int index,string w)
	{
		int present;
		int mp = 0;
		int ma = 0;
		 for (int i = 0; i < w.length(); i++)
		 {
		 	if(w[index]==c)
		 	{
		 	     mp = 1;
			 }
			 else
			 {
			 	present = 0;
			 	for(int i = 0;i<w.length();i++)
			 	 {
			 		if(w[i]==c)
			 		{
			 			ma = 1;
					 }
				 }
			 }
		 }
		 if(mp == 1)
		 {
		 	return ":)";
		 }
		 if(ma == 1)
		 {
		 	return ":|";
	}
		return ":(";
	}
	
	//play wordle game
	void ExtendedDictionary::wordle()
	{
		char char1,char2,char3,char4,char5;
		string res1,res2,res3,res4,res5;
		string guess;
		vector<string> fiveletters;
		for(int i = 0;i<words.size();i++)
		{
			if(words[i].name.length()==5)
			{
				fiveletters.push_back(words[i].name);
			}
		}
		string choosed = fiveletters[rand()%fiveletters.size()];
		cout<<"\n\nEnter five letter word. You have 6 attempts. [ #gray-> :( #yellow-> :| #green-> :) ]"<<endl;
		for(int i = 0;i<6;i++)
		{
		cout<<"\nAttempt"<<i+1<<":"<<endl;
		cin>>guess;
		transform(guess.begin(), guess.end(),guess.begin(), ::tolower);
		res1 = getresult(guess[0],0,choosed);
		res2 = getresult(guess[1],1,choosed);
		res3 = getresult(guess[2],2,choosed);
		res4 = getresult(guess[3],3,choosed);
		res5 = getresult(guess[4],4,choosed);
		cout<<" "<<guess[0]<<"  "<<guess[1]<<"  "<<guess[2]<<"  "<<guess[3]<<"  "<<guess[4]<<endl;
		cout<<res1<<" "<<res2<<" "<<res3<<" "<<res4<<" "<<res5<<endl;
		if(guess.compare(choosed)==0)
		{
			cout<<"You won!";
			return;
		}
	}
	cout<<"Ypu lost! the word is: "<<choosed<<endl;	
	}
	
	int main() {
	     string word;
	     ExtendedDictionary dict;
	     dict.loadDictionary();
	     int choice;
	    while(true)
	     	{
	     cout<<"\n1. List all words in the dictionary that are palindromes\r\n"<<"2. Check for anagrams corresponding to word given\r\n"<< "3. Play guessing game\r\n"<< "4. Play wordle\r\n"<< "5. Exit\r\n"<< "-----------------------"<<endl;
		 cin>>choice;
		 switch(choice)
		 {
		 	case 1:
	     //(a) List all words in the dictionary that are palindromes. e.g .civic
	     cout<<"All Palindromes:\n\n";
	     dict.showPalindromes();
	     break;
	     case 2:
	     //(b) Prompt the user for a word, and report all words that are anagrams of the word (e.g.admirer and married)
	     cout<<"\n\nEnter a word to check for anagram:"<<endl;
	     cin>>word;
	     transform(word.begin(), word.end(), word.begin(), ::tolower);
	     dict.showAnagrams(word);
	     break;
	     case 3:
	     /*(c) Guessing game  present the definition of a random noun and the length of that noun
	and ask the user to guess that noun, giving three tries. If the user guesses right, print a
	congratulatory message. After the first incorrect guess, reveal the first letter of the
	word, after the second incorrect guess reveal the second letter, after the third guess,
	print a commiseratory message and print the whole word.*/
	     cout<<"Guessing game started:\n\nDefinition:";
	     dict.guessingGame();
	     break;
	     case 4:
	     /*(d) Cheat at Wordle (see: https://www.nytimes.com/games/wordle/). Design, implement
	and test functionality that will allow the user to search for all five-letter words in the
	Dictionary that meet a set of parameters:*/
	    cout<<" Wordle game started:\n\n";
	     dict.wordle();
	     break;
	     case 5:
	     	exit(0);
	     default:
	     	cout<<"Invalid input";
	}
	}
	}
